/*
 * This file is generated by jOOQ.
 */
package com.alkemy.sophia.ripartizione.dbmodel.jooq.tables.records;


import com.alkemy.sophia.ripartizione.dbmodel.jooq.tables.DsrMetadata;

import java.math.BigDecimal;

import javax.annotation.Generated;

import org.jooq.Field;
import org.jooq.Record1;
import org.jooq.Record15;
import org.jooq.Row15;
import org.jooq.impl.UpdatableRecordImpl;


/**
 * This class is generated by jOOQ.
 */
@Generated(
    value = {
        "http://www.jooq.org",
        "jOOQ version:3.11.9"
    },
    comments = "This class is generated by jOOQ"
)
@SuppressWarnings({ "all", "unchecked", "rawtypes" })
public class DsrMetadataRecord extends UpdatableRecordImpl<DsrMetadataRecord> implements Record15<String, String, Long, BigDecimal, Long, String, Integer, String, Integer, Integer, String, String, Long, Short, String> {

    private static final long serialVersionUID = 1154945442;

    /**
     * Setter for <code>DSR_METADATA.IDDSR</code>.
     */
    public void setIddsr(String value) {
        set(0, value);
    }

    /**
     * Getter for <code>DSR_METADATA.IDDSR</code>.
     */
    public String getIddsr() {
        return (String) get(0);
    }

    /**
     * Setter for <code>DSR_METADATA.IDDSP</code>.
     */
    public void setIddsp(String value) {
        set(1, value);
    }

    /**
     * Getter for <code>DSR_METADATA.IDDSP</code>.
     */
    public String getIddsp() {
        return (String) get(1);
    }

    /**
     * Setter for <code>DSR_METADATA.SALES_LINES_NUM</code>.
     */
    public void setSalesLinesNum(Long value) {
        set(2, value);
    }

    /**
     * Getter for <code>DSR_METADATA.SALES_LINES_NUM</code>.
     */
    public Long getSalesLinesNum() {
        return (Long) get(2);
    }

    /**
     * Setter for <code>DSR_METADATA.TOTAL_VALUE</code>.
     */
    public void setTotalValue(BigDecimal value) {
        set(3, value);
    }

    /**
     * Getter for <code>DSR_METADATA.TOTAL_VALUE</code>.
     */
    public BigDecimal getTotalValue() {
        return (BigDecimal) get(3);
    }

    /**
     * Setter for <code>DSR_METADATA.SUBSCRIPTIONS_NUM</code>.
     */
    public void setSubscriptionsNum(Long value) {
        set(4, value);
    }

    /**
     * Getter for <code>DSR_METADATA.SUBSCRIPTIONS_NUM</code>.
     */
    public Long getSubscriptionsNum() {
        return (Long) get(4);
    }

    /**
     * Setter for <code>DSR_METADATA.CREATION_TIMESTAMP</code>.
     */
    public void setCreationTimestamp(String value) {
        set(5, value);
    }

    /**
     * Getter for <code>DSR_METADATA.CREATION_TIMESTAMP</code>.
     */
    public String getCreationTimestamp() {
        return (String) get(5);
    }

    /**
     * Setter for <code>DSR_METADATA.SERVICE_CODE</code>.
     */
    public void setServiceCode(Integer value) {
        set(6, value);
    }

    /**
     * Getter for <code>DSR_METADATA.SERVICE_CODE</code>.
     */
    public Integer getServiceCode() {
        return (Integer) get(6);
    }

    /**
     * Setter for <code>DSR_METADATA.PERIOD_TYPE</code>. "month" o "quarter"
     */
    public void setPeriodType(String value) {
        set(7, value);
    }

    /**
     * Getter for <code>DSR_METADATA.PERIOD_TYPE</code>. "month" o "quarter"
     */
    public String getPeriodType() {
        return (String) get(7);
    }

    /**
     * Setter for <code>DSR_METADATA.PERIOD</code>. se period_type == "month" --&gt; 1 2 3 4 5 6 7 8 9 10 11 12
se period_type == "quarter" --&gt; 1 2 3 4
     */
    public void setPeriod(Integer value) {
        set(8, value);
    }

    /**
     * Getter for <code>DSR_METADATA.PERIOD</code>. se period_type == "month" --&gt; 1 2 3 4 5 6 7 8 9 10 11 12
se period_type == "quarter" --&gt; 1 2 3 4
     */
    public Integer getPeriod() {
        return (Integer) get(8);
    }

    /**
     * Setter for <code>DSR_METADATA.YEAR</code>.
     */
    public void setYear(Integer value) {
        set(9, value);
    }

    /**
     * Getter for <code>DSR_METADATA.YEAR</code>.
     */
    public Integer getYear() {
        return (Integer) get(9);
    }

    /**
     * Setter for <code>DSR_METADATA.COUNTRY</code>.
     */
    public void setCountry(String value) {
        set(10, value);
    }

    /**
     * Getter for <code>DSR_METADATA.COUNTRY</code>.
     */
    public String getCountry() {
        return (String) get(10);
    }

    /**
     * Setter for <code>DSR_METADATA.CURRENCY</code>.
     */
    public void setCurrency(String value) {
        set(11, value);
    }

    /**
     * Getter for <code>DSR_METADATA.CURRENCY</code>.
     */
    public String getCurrency() {
        return (String) get(11);
    }

    /**
     * Setter for <code>DSR_METADATA.BACKCLAIM</code>. was backclaim requested for this dsr?
     */
    public void setBackclaim(Long value) {
        set(12, value);
    }

    /**
     * Getter for <code>DSR_METADATA.BACKCLAIM</code>. was backclaim requested for this dsr?
     */
    public Long getBackclaim() {
        return (Long) get(12);
    }

    /**
     * Setter for <code>DSR_METADATA.ID_BACKCLAIM_IN_PROGRESS</code>. 0 -&gt; not in progress, 1 -&gt; in progress, 2 -&gt; waiting for approval
     */
    public void setIdBackclaimInProgress(Short value) {
        set(13, value);
    }

    /**
     * Getter for <code>DSR_METADATA.ID_BACKCLAIM_IN_PROGRESS</code>. 0 -&gt; not in progress, 1 -&gt; in progress, 2 -&gt; waiting for approval
     */
    public Short getIdBackclaimInProgress() {
        return (Short) get(13);
    }

    /**
     * Setter for <code>DSR_METADATA.EXTENDED_DSR_URL</code>.
     */
    public void setExtendedDsrUrl(String value) {
        set(14, value);
    }

    /**
     * Getter for <code>DSR_METADATA.EXTENDED_DSR_URL</code>.
     */
    public String getExtendedDsrUrl() {
        return (String) get(14);
    }

    // -------------------------------------------------------------------------
    // Primary key information
    // -------------------------------------------------------------------------

    /**
     * {@inheritDoc}
     */
    @Override
    public Record1<String> key() {
        return (Record1) super.key();
    }

    // -------------------------------------------------------------------------
    // Record15 type implementation
    // -------------------------------------------------------------------------

    /**
     * {@inheritDoc}
     */
    @Override
    public Row15<String, String, Long, BigDecimal, Long, String, Integer, String, Integer, Integer, String, String, Long, Short, String> fieldsRow() {
        return (Row15) super.fieldsRow();
    }

    /**
     * {@inheritDoc}
     */
    @Override
    public Row15<String, String, Long, BigDecimal, Long, String, Integer, String, Integer, Integer, String, String, Long, Short, String> valuesRow() {
        return (Row15) super.valuesRow();
    }

    /**
     * {@inheritDoc}
     */
    @Override
    public Field<String> field1() {
        return DsrMetadata.DSR_METADATA.IDDSR;
    }

    /**
     * {@inheritDoc}
     */
    @Override
    public Field<String> field2() {
        return DsrMetadata.DSR_METADATA.IDDSP;
    }

    /**
     * {@inheritDoc}
     */
    @Override
    public Field<Long> field3() {
        return DsrMetadata.DSR_METADATA.SALES_LINES_NUM;
    }

    /**
     * {@inheritDoc}
     */
    @Override
    public Field<BigDecimal> field4() {
        return DsrMetadata.DSR_METADATA.TOTAL_VALUE;
    }

    /**
     * {@inheritDoc}
     */
    @Override
    public Field<Long> field5() {
        return DsrMetadata.DSR_METADATA.SUBSCRIPTIONS_NUM;
    }

    /**
     * {@inheritDoc}
     */
    @Override
    public Field<String> field6() {
        return DsrMetadata.DSR_METADATA.CREATION_TIMESTAMP;
    }

    /**
     * {@inheritDoc}
     */
    @Override
    public Field<Integer> field7() {
        return DsrMetadata.DSR_METADATA.SERVICE_CODE;
    }

    /**
     * {@inheritDoc}
     */
    @Override
    public Field<String> field8() {
        return DsrMetadata.DSR_METADATA.PERIOD_TYPE;
    }

    /**
     * {@inheritDoc}
     */
    @Override
    public Field<Integer> field9() {
        return DsrMetadata.DSR_METADATA.PERIOD;
    }

    /**
     * {@inheritDoc}
     */
    @Override
    public Field<Integer> field10() {
        return DsrMetadata.DSR_METADATA.YEAR;
    }

    /**
     * {@inheritDoc}
     */
    @Override
    public Field<String> field11() {
        return DsrMetadata.DSR_METADATA.COUNTRY;
    }

    /**
     * {@inheritDoc}
     */
    @Override
    public Field<String> field12() {
        return DsrMetadata.DSR_METADATA.CURRENCY;
    }

    /**
     * {@inheritDoc}
     */
    @Override
    public Field<Long> field13() {
        return DsrMetadata.DSR_METADATA.BACKCLAIM;
    }

    /**
     * {@inheritDoc}
     */
    @Override
    public Field<Short> field14() {
        return DsrMetadata.DSR_METADATA.ID_BACKCLAIM_IN_PROGRESS;
    }

    /**
     * {@inheritDoc}
     */
    @Override
    public Field<String> field15() {
        return DsrMetadata.DSR_METADATA.EXTENDED_DSR_URL;
    }

    /**
     * {@inheritDoc}
     */
    @Override
    public String component1() {
        return getIddsr();
    }

    /**
     * {@inheritDoc}
     */
    @Override
    public String component2() {
        return getIddsp();
    }

    /**
     * {@inheritDoc}
     */
    @Override
    public Long component3() {
        return getSalesLinesNum();
    }

    /**
     * {@inheritDoc}
     */
    @Override
    public BigDecimal component4() {
        return getTotalValue();
    }

    /**
     * {@inheritDoc}
     */
    @Override
    public Long component5() {
        return getSubscriptionsNum();
    }

    /**
     * {@inheritDoc}
     */
    @Override
    public String component6() {
        return getCreationTimestamp();
    }

    /**
     * {@inheritDoc}
     */
    @Override
    public Integer component7() {
        return getServiceCode();
    }

    /**
     * {@inheritDoc}
     */
    @Override
    public String component8() {
        return getPeriodType();
    }

    /**
     * {@inheritDoc}
     */
    @Override
    public Integer component9() {
        return getPeriod();
    }

    /**
     * {@inheritDoc}
     */
    @Override
    public Integer component10() {
        return getYear();
    }

    /**
     * {@inheritDoc}
     */
    @Override
    public String component11() {
        return getCountry();
    }

    /**
     * {@inheritDoc}
     */
    @Override
    public String component12() {
        return getCurrency();
    }

    /**
     * {@inheritDoc}
     */
    @Override
    public Long component13() {
        return getBackclaim();
    }

    /**
     * {@inheritDoc}
     */
    @Override
    public Short component14() {
        return getIdBackclaimInProgress();
    }

    /**
     * {@inheritDoc}
     */
    @Override
    public String component15() {
        return getExtendedDsrUrl();
    }

    /**
     * {@inheritDoc}
     */
    @Override
    public String value1() {
        return getIddsr();
    }

    /**
     * {@inheritDoc}
     */
    @Override
    public String value2() {
        return getIddsp();
    }

    /**
     * {@inheritDoc}
     */
    @Override
    public Long value3() {
        return getSalesLinesNum();
    }

    /**
     * {@inheritDoc}
     */
    @Override
    public BigDecimal value4() {
        return getTotalValue();
    }

    /**
     * {@inheritDoc}
     */
    @Override
    public Long value5() {
        return getSubscriptionsNum();
    }

    /**
     * {@inheritDoc}
     */
    @Override
    public String value6() {
        return getCreationTimestamp();
    }

    /**
     * {@inheritDoc}
     */
    @Override
    public Integer value7() {
        return getServiceCode();
    }

    /**
     * {@inheritDoc}
     */
    @Override
    public String value8() {
        return getPeriodType();
    }

    /**
     * {@inheritDoc}
     */
    @Override
    public Integer value9() {
        return getPeriod();
    }

    /**
     * {@inheritDoc}
     */
    @Override
    public Integer value10() {
        return getYear();
    }

    /**
     * {@inheritDoc}
     */
    @Override
    public String value11() {
        return getCountry();
    }

    /**
     * {@inheritDoc}
     */
    @Override
    public String value12() {
        return getCurrency();
    }

    /**
     * {@inheritDoc}
     */
    @Override
    public Long value13() {
        return getBackclaim();
    }

    /**
     * {@inheritDoc}
     */
    @Override
    public Short value14() {
        return getIdBackclaimInProgress();
    }

    /**
     * {@inheritDoc}
     */
    @Override
    public String value15() {
        return getExtendedDsrUrl();
    }

    /**
     * {@inheritDoc}
     */
    @Override
    public DsrMetadataRecord value1(String value) {
        setIddsr(value);
        return this;
    }

    /**
     * {@inheritDoc}
     */
    @Override
    public DsrMetadataRecord value2(String value) {
        setIddsp(value);
        return this;
    }

    /**
     * {@inheritDoc}
     */
    @Override
    public DsrMetadataRecord value3(Long value) {
        setSalesLinesNum(value);
        return this;
    }

    /**
     * {@inheritDoc}
     */
    @Override
    public DsrMetadataRecord value4(BigDecimal value) {
        setTotalValue(value);
        return this;
    }

    /**
     * {@inheritDoc}
     */
    @Override
    public DsrMetadataRecord value5(Long value) {
        setSubscriptionsNum(value);
        return this;
    }

    /**
     * {@inheritDoc}
     */
    @Override
    public DsrMetadataRecord value6(String value) {
        setCreationTimestamp(value);
        return this;
    }

    /**
     * {@inheritDoc}
     */
    @Override
    public DsrMetadataRecord value7(Integer value) {
        setServiceCode(value);
        return this;
    }

    /**
     * {@inheritDoc}
     */
    @Override
    public DsrMetadataRecord value8(String value) {
        setPeriodType(value);
        return this;
    }

    /**
     * {@inheritDoc}
     */
    @Override
    public DsrMetadataRecord value9(Integer value) {
        setPeriod(value);
        return this;
    }

    /**
     * {@inheritDoc}
     */
    @Override
    public DsrMetadataRecord value10(Integer value) {
        setYear(value);
        return this;
    }

    /**
     * {@inheritDoc}
     */
    @Override
    public DsrMetadataRecord value11(String value) {
        setCountry(value);
        return this;
    }

    /**
     * {@inheritDoc}
     */
    @Override
    public DsrMetadataRecord value12(String value) {
        setCurrency(value);
        return this;
    }

    /**
     * {@inheritDoc}
     */
    @Override
    public DsrMetadataRecord value13(Long value) {
        setBackclaim(value);
        return this;
    }

    /**
     * {@inheritDoc}
     */
    @Override
    public DsrMetadataRecord value14(Short value) {
        setIdBackclaimInProgress(value);
        return this;
    }

    /**
     * {@inheritDoc}
     */
    @Override
    public DsrMetadataRecord value15(String value) {
        setExtendedDsrUrl(value);
        return this;
    }

    /**
     * {@inheritDoc}
     */
    @Override
    public DsrMetadataRecord values(String value1, String value2, Long value3, BigDecimal value4, Long value5, String value6, Integer value7, String value8, Integer value9, Integer value10, String value11, String value12, Long value13, Short value14, String value15) {
        value1(value1);
        value2(value2);
        value3(value3);
        value4(value4);
        value5(value5);
        value6(value6);
        value7(value7);
        value8(value8);
        value9(value9);
        value10(value10);
        value11(value11);
        value12(value12);
        value13(value13);
        value14(value14);
        value15(value15);
        return this;
    }

    // -------------------------------------------------------------------------
    // Constructors
    // -------------------------------------------------------------------------

    /**
     * Create a detached DsrMetadataRecord
     */
    public DsrMetadataRecord() {
        super(DsrMetadata.DSR_METADATA);
    }

    /**
     * Create a detached, initialised DsrMetadataRecord
     */
    public DsrMetadataRecord(String iddsr, String iddsp, Long salesLinesNum, BigDecimal totalValue, Long subscriptionsNum, String creationTimestamp, Integer serviceCode, String periodType, Integer period, Integer year, String country, String currency, Long backclaim, Short idBackclaimInProgress, String extendedDsrUrl) {
        super(DsrMetadata.DSR_METADATA);

        set(0, iddsr);
        set(1, iddsp);
        set(2, salesLinesNum);
        set(3, totalValue);
        set(4, subscriptionsNum);
        set(5, creationTimestamp);
        set(6, serviceCode);
        set(7, periodType);
        set(8, period);
        set(9, year);
        set(10, country);
        set(11, currency);
        set(12, backclaim);
        set(13, idBackclaimInProgress);
        set(14, extendedDsrUrl);
    }
}
